package com.loit.shardingsphere.seata.nacos.feign.modules.service.impl;

import com.loit.shardingsphere.seata.nacos.feign.modules.entity.OrderEntity;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IBusinessService;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service("businessService")
public class BusinessServiceImpl implements IBusinessService {

    @Autowired
    IOrderService orderService;

    /**
     * 分库分表 使用全局事务
     *
     * @param userId
     */
   /* @Override
    @ShardingTransactionType(TransactionType.BASE)
    @GlobalTransactional
    public void purchase(Long userId) {
        if (userId == null) {
            return;
        }
        TransactionTypeHolder.set(TransactionType.BASE);
        OrderEntity orderEntity = new OrderEntity();
        orderEntity.setOrderId(userId);
        orderEntity.setStatus("seata");
        orderEntity.setUserId(userId.intValue());
        orderService.insertOrder(orderEntity);
        //throw new RuntimeException("回滚测试");
    }*/


    /**
     * 分表 使用本地事务
     *
     * @param userId
     */
    @Override
    @Transactional
    @Async
    public void purchase(Long userId) {
        if (userId == null) {
            return;
        }
        OrderEntity orderEntity = new OrderEntity();
        orderEntity.setOrderId(userId);
        orderEntity.setStatus("seata");
        orderEntity.setUserId(userId.intValue());
        orderService.insertOrder(orderEntity);
        //throw new RuntimeException("回滚测试");
    }
}
