package com.loit.shardingsphere.seata.nacos.feign.modules.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.loit.shardingsphere.seata.nacos.feign.modules.entity.OrderItemEntity;
import com.loit.shardingsphere.seata.nacos.feign.modules.mapper.OrderItemMapper;
import com.loit.shardingsphere.seata.nacos.feign.modules.service.IOrderItemService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service("orderItemService")
public class OrderItemServiceImpl extends ServiceImpl<OrderItemMapper, OrderItemEntity> implements IOrderItemService {

    @Override
    @Transactional
    public void insertOrderItem(OrderItemEntity orderItemEntity) {
        baseMapper.insert(orderItemEntity);
    }

    @Override
    public List<OrderItemEntity> findPage(Long orderId, Long pageNum, Long pageSize) {
        QueryWrapper<OrderItemEntity> queryWrapper = new QueryWrapper<>();

        queryWrapper.eq("order_id", orderId);
        queryWrapper.orderByAsc("id");
        Page<OrderItemEntity> page = new Page<>(pageNum, pageSize);
        //分页数据
        IPage<OrderItemEntity> pageInfo = this.page(page, queryWrapper);
        return pageInfo.getRecords();
    }
}
